import 'dart:convert';

import 'package:fluttertoast/fluttertoast.dart';
import 'package:get/get.dart';
import 'package:http/http.dart' as http;
import 'package:zigzagbus/helper/colornotifier.dart';

import '../config.dart';
import '../helper/filldetails.dart';

class MsgOtpController extends GetxController implements GetxService {

  bool isLoading = false;
  Future smstype() async {

    var response = await http.get(Uri.parse(Config.baseUrl + Config.smstype),
        headers: {'Content-Type': 'application/json',}
    );

    if(response.statusCode == 200){
      var smsType = jsonDecode(response.body);
      update();
      print(" SMS CODE TYPE >>>>>>>>>>>>>> : : : : : :${smsType["SMS_TYPE"]}");
      return smsType;
    }
  }

  bool msgCheck = false;
  String otpCode = "";

  Future sendOtp({required String mobile}) async {
    print("MOBILE MSG #$mobile");
    Map body = {
      "mobile": mobile,
    };

    var response = await http.post(Uri.parse(Config.baseUrl + Config.msgotp),
        body: jsonEncode(body),
        headers: {'Content-Type': 'application/json',}
    );
    print("><<<<<<<<<<<<<<<<<<$body");

    if(response.statusCode == 200){
      var msgdecode = jsonDecode(response.body);

      if(msgdecode["Result"] == "true"){

        var msgotpData = jsonDecode(response.body);
        msgCheck = bool.parse(msgotpData["Result"]);
        otpCode = msgotpData["otp"].toString();
        print("><<<<<<<<<<<<<<<<<<$otpCode");
        update();
        return msgdecode;
      } else {
        Fluttertoast.showToast(
          toastLength: Toast.LENGTH_LONG,
          webBgColor: notifier.isDark ? "linear-gradient(to right, #ffffff, #ffffff)" : "linear-gradient(to right, #000000, #000000)" ,
          msg: msgdecode["ResponseMsg"],
          textColor: notifier.blackwhitecolor,
        );
      }
    } else {
      Fluttertoast.showToast(
        toastLength: Toast.LENGTH_LONG,
        webBgColor: notifier.isDark ? "linear-gradient(to right, #ffffff, #ffffff)" : "linear-gradient(to right, #000000, #000000)" ,
        msg: "Something went wrong!",
        textColor: notifier.blackwhitecolor,
      );
    }
  }

  String twilloCode = "";
  bool twillioCheck = false;
  Future twilloOtp({required String mobile}) async {
    print("MOBILE Twillio #$mobile");
    Map body = {
      "mobile" : mobile
    };

    var response = await http.post(Uri.parse(Config.baseUrl + Config.twillotp),
        body: jsonEncode(body),
        headers: {'Content-Type': 'application/json',}
    );
    print("><<<<<<<<<<<<<<<<<<$body");

    if(response.statusCode == 200){
      var msgdecode = jsonDecode(response.body);

      if(msgdecode["Result"] == "true"){
        print(" OTP CODE : >>> ${msgdecode["otp"]}");
        update();
        return msgdecode;
      } else {
        Fluttertoast.showToast(
          toastLength: Toast.LENGTH_LONG,
          webBgColor: notifier.isDark ? "linear-gradient(to right, #ffffff, #ffffff)" : "linear-gradient(to right, #000000, #000000)" ,
          msg: msgdecode["ResponseMsg"],
          textColor: notifier.blackwhitecolor,
        );
      }
    } else {
      Fluttertoast.showToast(
        toastLength: Toast.LENGTH_LONG,
        webBgColor: notifier.isDark ? "linear-gradient(to right, #ffffff, #ffffff)" : "linear-gradient(to right, #000000, #000000)" ,
        msg: "Something went wrong!",
        textColor: notifier.blackwhitecolor,
      );
    }
  }

}
