// ignore_for_file: prefer_typing_uninitialized_variables

import 'package:flutter/cupertino.dart';
import 'package:flutter/services.dart';
import 'package:flutter_otp_text_field/flutter_otp_text_field.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:intl_phone_field/intl_phone_field.dart';
import 'package:otp_text_field/otp_field.dart';
import 'package:pinput/pinput.dart';
import 'package:zigzagbus/apicontroller/fogotpasscontroller.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:provider/provider.dart';

import '../../apicontroller/loginapicontroller.dart';
import '../../apicontroller/mobilecheckcontroller.dart';
import '../../apicontroller/msgotp.dart';
import '../../mediaquery/mq.dart';
import '../colornotifier.dart';
import '../logindialog.dart';
import 'firebaseauth.dart';
class ForgotPassword extends StatefulWidget {
  const ForgotPassword({super.key});

  @override
  State<ForgotPassword> createState() => _ForgotPasswordState();
}

class _ForgotPasswordState extends State<ForgotPassword> {
  late ColorNotifier notifier;

  ForgotPassController forgotPassApi = Get.put(ForgotPassController());
  MobileCkeckController mobileCheckApi = Get.put(MobileCkeckController());
  MsgOtpController msgOtpCont = Get.put(MsgOtpController());

  String otpPin = "";
  String pin = "";

  var temp;

  OtpFieldController otpcont = OtpFieldController();
  TextEditingController mobile = TextEditingController();
  TextEditingController pass1 = TextEditingController();
  TextEditingController pass2 = TextEditingController();
  @override
  Widget build(BuildContext context) {
    notifier = Provider.of<ColorNotifier>(context, listen: true);
    height = MediaQuery.of(context).size.height;
    width = MediaQuery.of(context).size.width;
    return LayoutBuilder(builder: (context, constraints) {
      return forgotDialog(context, constraints);
    },);
  }

  String ccode = "91";
  bool getLoading = false;
  Widget forgotDialog(context, constraints){
    return SizedBox(
      width: 400,
      height: 350,
      child: Padding(
        padding: const EdgeInsets.all(50),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            Text('Enter mobile number'.tr,style: TextStyle(fontSize: 28,color: notifier.blackcolor,fontFamily: 'SofiaBold'),),
            const SizedBox(height: 40),
            IntlPhoneField(
              disableLengthCheck: true,
              controller: mobile,
              disableAutoFillHints: true,
              style: TextStyle(fontSize: 16,color: notifier.blackcolor,fontFamily: 'SofiaLight'),
              keyboardType: TextInputType.number,
              inputFormatters: <TextInputFormatter>[
                FilteringTextInputFormatter.digitsOnly,
              ],
              decoration: InputDecoration(
                contentPadding: const EdgeInsets.only(left: 12),
                hintText: 'Phone Number'.tr,
                hintStyle: TextStyle(fontSize: 14,color: notifier.subgreycolor,fontFamily: 'SofiaLight'),
                enabledBorder: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(12),
                  borderSide: BorderSide(color: notifier.sugestionbutton),
                ),
                focusedBorder: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(12),
                  borderSide: BorderSide(color: notifier.sugestionbutton),
                ),
              ),
              showCountryFlag: false,
              showDropdownIcon: false,
              dropdownTextStyle: TextStyle(fontSize: 14,color: notifier.blackcolor,fontWeight: FontWeight.w600,fontFamily: 'SofiaLight'),
              initialCountryCode: 'IN',
              onCountryChanged: (value) {
                setState(() {
                  ccode = value.dialCode;
                });
              },
              onChanged: (phone) {

              },
            ),
            const SizedBox(height: 40),
            Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: [
                const Spacer(),
                InkWell(
                  onTap: () {
                    Get.back();
                  },
                  child: Text("Back".tr,style: TextStyle(fontSize: 14,color: notifier.blackcolor,fontFamily: 'SofiaLight',fontWeight: FontWeight.w600),),
                ),
                const Spacer(),
                ElevatedButton(
                    style: ButtonStyle(
                      elevation: const MaterialStatePropertyAll(0),
                      shape: MaterialStatePropertyAll(RoundedRectangleBorder(borderRadius: BorderRadius.circular(12))),
                      backgroundColor: WidgetStatePropertyAll(notifier.purplecolor),
                    ),
                    onPressed: () {
                      popup();
                      forpassvalid(context, constraints);
                    }, child: Padding(
                  padding: const EdgeInsets.only(top: 6, bottom: 6, right: 30, left: 30),
                  child: Text("Next".tr,style: const TextStyle(fontSize: 18,color: Colors.white,fontFamily: 'SofiaLight',fontWeight: FontWeight.w600),),
                )),
              ],
            ),
          ],
        ),
      ),
    );
  }

  Future popup(){
    return showDialog(
      barrierDismissible: false,
      context: context, builder: (BuildContext context) {
      return Center(
        child: CircularProgressIndicator(color: Colors.deepPurpleAccent,),
      );
    },
    );
  }

  forpassvalid(context, constraints){
    if(mobile.text.length == 10){

      mobileCheckApi.mobileCheck(context, mobile.text, ccode).then((value) async {

          if(value["Result"] == "true"){
            Fluttertoast.showToast(
              toastLength: Toast.LENGTH_LONG,
              webBgColor: notifier.isDark ? "linear-gradient(to right, #ffffff, #ffffff)" : "linear-gradient(to right, #000000, #000000)" ,
              msg: 'Please enter your mobile number currectly!'.tr,
              textColor: notifier.blackwhitecolor,
            );
            Get.back();
          } else {
            msgOtpCont.smstype().then((msgType) {
              if (msgType["otp_auth"] == "No") {
                Get.back();
                Get.dialog(
                  Dialog(
                    backgroundColor: notifier.whitecolor,
                    shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(14)),
                    child: changePass(context,constraints),
                  ),
                  barrierDismissible: false, // Prevent dismissal by tapping outside
                );
              } else {
                Get.back();
                if (msgType["SMS_TYPE"] == "Msg91") {
                  msgOtpCont
                      .sendOtp(mobile: ccode + mobile.text)
                      .then((value) {
                        print("RESULT > > $value");
                    if (value["Result"] == "true") {
                      Get.back();
                      Get.dialog(
                        Dialog(
                          backgroundColor: notifier.whitecolor,
                          shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(14)),
                          child: otpField(context, constraints, ccode+mobile.text, value["otp"].toString()),
                        ),
                        barrierDismissible: false,
                      );
                    }
                  });
                } else if (msgType["SMS_TYPE"] == "Twilio") {
                  msgOtpCont
                      .twilloOtp(mobile: ccode + mobile.text)
                      .then((value) {
                    if (value["Result"] == "true") {
                      Get.back();
                      Get.dialog(
                        Dialog(
                          backgroundColor: notifier.whitecolor,
                          shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(14)),
                          child: otpField(context, constraints, ccode+mobile.text, value["otp"].toString()),
                        ),
                        barrierDismissible: false, // Prevent dismissal by tapping outside
                      );
                    }
                  });
                }
              }
            },);
            // showDialog(
            //   barrierDismissible: false,
            //   context: context,
            //   builder: (context) {
            //   return Dialog(
            //     backgroundColor: notifier.whitecolor,
            //     shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(14)),
            //     child: otpField(context, constraints, ),
            //   );
            // },);
            // _signInWithMobileNumber1(context);
           // temp = await FirebaseAuthenticati ̰on().sendOTP(mobile.text);
          }
      });
    } else {
      Fluttertoast.showToast(
        toastLength: Toast.LENGTH_LONG,
        webBgColor: notifier.isDark ? "linear-gradient(to right, #ffffff, #ffffff)" : "linear-gradient(to right, #000000, #000000)" ,
        msg: 'Please enter your mobile number currectly!'.tr,
        textColor: notifier.blackwhitecolor,
      );
    }
  }
  TextEditingController otpCont = TextEditingController();
  Widget otpField(context, constraints, mobile, otpcode){
    return SizedBox(
      width: 390,
      height: 350,
      child: Padding(
        padding: const EdgeInsets.all(20),
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.center,
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            Text('Enter OTP'.tr,style: TextStyle(fontSize: 28,color: notifier.blackcolor,fontFamily: 'SofiaBold'),),
            const SizedBox(height: 40),
            Pinput(
              length: 6,
              controller: otpCont,
              onSubmitted: (val) {},
              onChanged: (val) {},
              showCursor: true,
              onCompleted: (value) {
                  pin = value;
              },
              defaultPinTheme: PinTheme(
                height: constraints.maxWidth < 600 ? 30 : 50,
                width: constraints.maxWidth < 600 ? 30 : 50,
                decoration: BoxDecoration(
                  color: Colors.transparent,
                    borderRadius: BorderRadius.circular(10.0),
                    border: Border.all(color: CupertinoColors.systemGrey5,width: 2)
                ),
              ),
              focusedPinTheme: PinTheme(
                height: constraints.maxWidth < 600 ? 30 : 50,
                width: constraints.maxWidth < 600 ? 30 : 50,
                decoration: BoxDecoration(
                  color: Colors.transparent,
                  borderRadius: BorderRadius.circular(10.0),
                  border: Border.all(color: notifier.purplecolor, width: 2)
                ),
              ),
              // submittedPinTheme: PinTheme(
              //   decoration: BoxDecoration(
              //       color: Colors.white,
              //       borderRadius: BorderRadius.circular(10.0),
              //       border: Border.all(color: Colors.grey)
              //   ),
              // ),
            ),
            const SizedBox(height: 20),
            InkWell(
              onTap: () {
                otpCont.text = "";
                msgOtpCont.smstype().then((msgType) {
                  if (msgType["SMS_TYPE"] == "Msg91") {
                    msgOtpCont
                        .sendOtp(mobile: mobile)
                        .then((value) {
                      otpCont.text = "";
                    });
                  } else if (msgType["SMS_TYPE"] == "Twilio") {
                    msgOtpCont
                        .twilloOtp(mobile: mobile)
                        .then((value) {
                      otpCont.text = "";
                    });
                  }
                },);

              },
                child: Text("Re-send",style: TextStyle(fontSize: 14,color: notifier.purplecolor,fontFamily: 'SofiaLight',fontWeight: FontWeight.w600),textAlign: TextAlign.end,),
            ),
            const SizedBox(height: 30),
            Padding(
              padding: const EdgeInsets.only(right: 20, left: 20),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.center,
                children: [
                  const Spacer(),
                  InkWell(
                    onTap: () {
                      Get.back();
                    },
                    child: Text("Back".tr,style: TextStyle(fontSize: 14,color: notifier.blackcolor,fontFamily: 'SofiaLight',fontWeight: FontWeight.w600),),
                  ),
                  const Spacer(),
                  ElevatedButton(
                      style: ButtonStyle(
                        elevation: const MaterialStatePropertyAll(0),
                        shape: MaterialStatePropertyAll(RoundedRectangleBorder(borderRadius: BorderRadius.circular(12))),
                        backgroundColor: WidgetStatePropertyAll(notifier.purplecolor),
                      ),
                      onPressed: () {
                        if(pin == otpcode){
                          Get.back();
                          Get.dialog(
                            Dialog(
                              backgroundColor: notifier.whitecolor,
                              shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(14)),
                              child: changePass(context,constraints),
                            ),
                            barrierDismissible: false, // Prevent dismissal by tapping outside
                          );
                        } else {
                            Fluttertoast.showToast(
                              toastLength: Toast.LENGTH_LONG,
                              webBgColor: notifier.isDark ? "linear-gradient(to right, #ffffff, #ffffff)" : "linear-gradient(to right, #000000, #000000)" ,
                              msg: 'Something Went wrong!'.tr,
                              textColor: notifier.blackwhitecolor,
                            );
                        }
                        // FirebaseAuthentication().authenticateMe(temp, pin).then((value){
                        //   if(value){
                        //
                        //   } else {
                        //    }
                        // });

                      }, child: Padding(
                    padding: const EdgeInsets.only(top: 6, bottom: 6, right: 30, left: 30),
                    child: Text("Next".tr,style: const TextStyle(fontSize: 18,color: Colors.white,fontFamily: 'SofiaLight',fontWeight: FontWeight.w600),),
                  )),
                ],
              ),
            ),
          ],
        ),
      ),
    );
  }
  Widget changePass(context, constraints){
    return SizedBox(
      width: 350,
      height: 350,
      child: Padding(
        padding: const EdgeInsets.all(50),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            Text('Change Password'.tr,style: TextStyle(fontSize: 28,color: notifier.blackcolor,fontFamily: 'SofiaBold'),),
            const SizedBox(height: 30),
            TextField(
              controller: pass1,
              decoration: InputDecoration(
                contentPadding: const EdgeInsets.only(left: 12),
                hintText: 'Enter new password'.tr,
                hintStyle: TextStyle(fontSize: 14,color: notifier.subgreycolor,fontFamily: 'SofiaLight'),
                enabledBorder: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(12),
                  borderSide: BorderSide(color: notifier.sugestionbutton),
                ),
                focusedBorder: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(12),
                  borderSide: BorderSide(color: notifier.sugestionbutton),
                ),
              ),
            ),
            const SizedBox(height: 10),
            TextField(
              controller: pass2,
              decoration: InputDecoration(
                contentPadding: const EdgeInsets.only(left: 12),
                hintText: 'Re-Enter password'.tr,
                hintStyle: TextStyle(fontSize: 14,color: notifier.subgreycolor,fontFamily: 'SofiaLight'),
                enabledBorder: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(12),
                  borderSide: BorderSide(color: notifier.sugestionbutton),
                ),
                focusedBorder: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(12),
                  borderSide: BorderSide(color: notifier.sugestionbutton),
                ),
              ),
            ),
            const SizedBox(height: 30),
            Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: [
                const Spacer(),
                InkWell(
                  onTap: () {
                    Get.back();
                  },
                  child: Text("Back".tr,style: TextStyle(fontSize: 14,color: notifier.blackcolor,fontFamily: 'SofiaLight',fontWeight: FontWeight.w600),),
                ),
                const Spacer(),
                GetBuilder<LoginApiController>(
                  builder: (logInApi) {
                    return ElevatedButton(
                        style: ButtonStyle(
                          shape: MaterialStatePropertyAll(RoundedRectangleBorder(borderRadius: BorderRadius.circular(12))),
                          backgroundColor: WidgetStatePropertyAll(notifier.purplecolor),
                        ),
                        onPressed: () {
                          if(pass1.text == pass2.text){
                            Get.back();
                            forgotPassApi.forgotPassword(context, mobile.text, pass2.text).then((value) {
                              showDialog(
                                context: context, builder: (context) {
                                return Dialog(
                                    shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(14)),
                                    insetPadding: const EdgeInsets.all(20),
                                    child: const LoginDialog());
                              },
                              ).then((value) {
                                setState(() {
                                  logInApi.getlocaldata();
                                });
                              });
                              if(value["Result"] == "true"){
                                Fluttertoast.showToast(
                                  toastLength: Toast.LENGTH_LONG,
                                  webBgColor: notifier.isDark ? "linear-gradient(to right, #ffffff, #ffffff)" : "linear-gradient(to right, #000000, #000000)" ,
                                  msg: value["ResponseMsg"],
                                  textColor: notifier.blackwhitecolor,
                                );
                              } else {
                                Fluttertoast.showToast(
                                  toastLength: Toast.LENGTH_LONG,
                                  webBgColor: notifier.isDark ? "linear-gradient(to right, #ffffff, #ffffff)" : "linear-gradient(to right, #000000, #000000)" ,
                                  msg: value["ResponseMsg"],
                                  textColor: notifier.blackwhitecolor,
                                );
                              }
                            });
                          } else {
                            Fluttertoast.showToast(
                              toastLength: Toast.LENGTH_LONG,
                              webBgColor: notifier.isDark ? "linear-gradient(to right, #ffffff, #ffffff)" : "linear-gradient(to right, #000000, #000000)" ,
                              msg: "Password do not match",
                              textColor: notifier.blackwhitecolor,
                            );
                          }
                          forpassvalid(context,constraints);
                        }, child: Padding(
                      padding: const EdgeInsets.only(top: 6, bottom: 6, right: 30, left: 30),
                      child: Text("Next".tr,style: const TextStyle(fontSize: 18,color: Colors.white,fontFamily: 'SofiaLight',fontWeight: FontWeight.w600),),
                    ));
                  }
                ),
              ],
            )
          ],
        ),
      ),
    );
  }

}
